program mp3req;

Uses
crt, door32;

const
  strlength = 50;

type
  stringtype = string[strlength];
  mp3records = record
	uname, artist, song, album, trade : stringtype;
   end;

  mp3file = file of mp3records;

var
  f : mp3file;
  onerecord : mp3records;
  choice : string;
  acs, x, ch1 : integer;
  ans : string;
  yn : char;
  cfg : text;

procedure outro;
begin
repeat
SendCLS;
sendfile('outro.ans', FALSE);
Send('|15Press |08[|07enter|08]');
until GetKey = #13;
exit
end;

Procedure intro;
begin
ch1 := 0;
If ch1 < 1 then
begin
repeat
SendCLS;
Sendfile('mp3req.ans', FALSE);
Send('|15Press |08[|07enter|08]');
Until GetKey = #13;
ch1 := ch1 + 1;
end;
end;

procedure menu;
begin
SendCLS;
Sendfile('mp3mnu.ans', FALSE);
Send('|CR|CR');
end;

procedure displaydata;
begin
repeat
 x := 1;
	read(f, onerecord);
    Send('|15');
    Writeln(x);
    Send('|04Requester:|12                         ' + onerecord.uname);
	Send('|CR');
    Send('|04Artist:|12                         ' + onerecord.artist);
	Send('|CR');
    Send('|04Song Name:|12                      ' + onerecord.song);
	Send('|CR');
    Send('|04Album:|12                          ' + onerecord.album);
	Send('|CR');
    Send('|04Method of Trading:|12              ' + onerecord.trade);
	Send('|CR');
Send('|08-------------------------------------------------------------|CR');
        x := x + 1;
Send('[q] to quit [enter] to continue');
        readln(ans);
	  if ans = 'q' then
          exit
          else
	until EOF(f);
end;

procedure delrecord;
var
i, no, total : integer;
r : mp3records;
position : longint;
  begin
    assign(f, 'mp3rcrds.dat');
if not (fexist('mp3rcrds.dat')) then
begin
repeat
Send('|15No records exist');
Send('|CR|CR');
Send('|15Press |08[|07enter|08]');
Until GetKey = #13;
exit
end;
    reset(f);
Send('|15Would you like to display records first? y/n ');
readln(yn);
if (yn = 'Y') or (yn = 'y') then
begin
    SendCLS;
    Sendfile('mp3hdr.ans', FALSE);
    Send('|CR');
	displaydata;
repeat
Send('|15Which one do you want to delete? enter 0 to quit ');
readln(no);
if no = 0 then
exit
else
assign (f, 'mp3rcrds.dat');
reset(f);
if ioresult <> 0 then
begin
rewrite(f);
if ioresult <> 0 then
begin
send('|15could not create file');
exit
end
end;
total := filesize(f);
if (no > total) then begin
writeln ('Can''t delete an item that doesn''t exist.');
close (f);
exit
end;
 if no = total then begin
    seek (f, filesize(f)-1);
    truncate (f)
  end
  else begin
    position := no;
    for i := 1 to total-no do begin
      seek (f, position);
      read (f, r);
      seek (f, position-1);
      write (f, r);
      inc (position)
    end;
    seek (f, filesize(f)-1);
    truncate (f)
  end;
  close (f);
until no = 0
end;
end;

procedure writerecord (var onerecord: mp3records);
begin
    
    write (f, onerecord);
    close (f);
end;

procedure addrecord (var onerecord : mp3records);
begin
  SendCLS;
  with onerecord do
   begin
   Sendfile('addmp3.ans', FALSE);
   Send('|CR');
   uname := user_handle;
   Send('|04Enter Artists Name:|12 ');
   readln (artist);
   if artist <> '' then
      begin
	assign (f, 'mp3rcrds.dat');
	if (fexist('mp3rcrds.dat')) then
	  begin
	  reset(f);
	  seek(f,filesize(f));
	  end
	else
	  rewrite(f);
	  end;
     Send ('|04Enter Song Title if any:|12 ');
      readln(song);
      Send ('|04Enter Album Title:|12 ');
      readln(album);
      Send('|04Enter method of trading: |12');
      readln(trade);
      end; {if artist}
Send('Do you want to add this? y/n ');
readln(yn);
if (yn = 'Y') or (yn = 'y') then
begin
writerecord(onerecord);
end
else
exit;
end; {addrecord}



procedure displayreq;
begin
    SendCLS;
    Sendfile('mp3hdr.ans', FALSE);
    Send('|CR');
    assign(f, 'mp3rcrds.dat');
if not (fexist('mp3rcrds.dat')) then
begin
repeat
Send('|15No records exist');
Send('|CR|CR');
Send('|15Press |08[|07enter|08]');
Until GetKey = #13;
exit
end;
    reset(f);
	displaydata;
	close(f);
end;


Var
  Res : Byte;
Begin
  If ParamCount <> 1 Then Begin
    WriteLn;
    WriteLn ('mp3req : Mp3 Request door');
    WriteLn;
    WriteLn ('Syntax  : mp3req <Path and filename of drop file>');
    {$IFNDEF MSDOS}
      {$IFDEF LINUX}
        WriteLn ('Example : mp3req /bbs/door32.sys');
        WriteLn ('          mp3req /bbs/door.sys');
        WriteLn ('          mp3req /bbs/door/dorinfo1.def');
        WriteLn ('          mp3req /bbs/chain.txt');
      {$ELSE}
        WriteLn ('Example : MP3REQ C:\BBS\DOOR32.SYS');
      {$ENDIF}
    {$ELSE}
      WriteLn ('Example : MP3REQ C:\BBS\DORINFO1.DEF');
      WriteLn ('          MP3REQ C:\BBS\DOOR.SYS');
      WriteLn ('          MP3REQ C:\BBS\CHAIN.TXT');
    {$ENDIF}
    Halt;
  End;

  Res := OpenDOOR(ParamStr(1));

  Case Res of
    1 : WriteLn ('ERROR: Drop file not found.');
    2 : WriteLn ('ERROR: Error reading drop file');
    3 : WriteLn ('ERROR: Unknown drop file type');
    4 : WriteLn ('ERROR: Unable to open communications port');
  End;

  If Res <> 0 Then Halt;

intro;
repeat
menu;
Send('                |15 ' + user_handle + ' |07enter choice|08> ');
readln(choice);   
if choice = '1' then
begin
addrecord (onerecord)
end;
if choice = '2' then
displayreq;
if choice = '3' then
begin
assign(cfg,'mp3req.cfg');
reset(cfg);
ReadLn(cfg, acs);
If User_Security > acs then 
begin
delrecord;
end
else
repeat
Send('|15Sorry, your ACS isn''t high enough to access this option');
until GetKey = #13
end;
if choice = 'q' then
outro;
until choice = 'q';
CloseDOOR;
end.  